#include "libnazgul.h"

#define NONBLOCK -1

void * msgGet(msgSpace * space,int queueIndex,int option){
  void * resultAddr;
  msgQueueId queueId;
  msgQueue * queue;
  msgQueueElemId oldElemId;
 msgQueueElem * oldElem;
  // on teste la possibilit de lecture sur la liste...
  if (option == NONBLOCK){
	if (msgQueueReadTryLock(space->externId,queueIndex) <0){
	  NZG_ERROR("msgQueueReadTryLock",space->externId);
	  goto ERROR;
	}
  } else {
	if (msgQueueReadLock(space->externId,queueIndex) <0){
	  NZG_ERROR("msgQueueReadLock",space->externId);
	  goto ERROR;
	}
  }
  // la lecture est possible
  // on essaye donc de modifier la liste
  msgQueueProtLock(space->externId,queueIndex);
  msgQueueIdIntern(queueId,space->externId,queueIndex);
  // ouvrir la file 
  queue = msgQueueOpen(queueId);

  // recuprer l'id de l'ancien element...
  msgQueueRem(queue, oldElemId);

 oldElem = msgQueueElemOpen(oldElemId);

 // mapper le buffer dans l'espace mmoire du processus
 // attacher au buffer...
 
  // fermer la file
  msgQueueClose(queue);

  // on a fini de modifier la liste
  msgQueueProtUnlock(space->externId,queueIndex);

  return resultAddr;
ERROR:
  return NULL;
}
